//this class is responsable for printing out information to the terminal and the receiving input from the user whenever
//entry a key and press enter
import 'dart:io';
import 'option.dart';

class Terminal {
  const Terminal();
  //void means no return to the method at any time
  //and promprt to receive prompt as an argument to this function
  void printPrompt(String prompt) {
    //dart:io already create an instance of Stdout class, just use reference of stdout propertie and call the whriteln method
    stdout.writeln(prompt);
  }

  void printOptions(List<Option> options) {
//    for (var i = 0; i < options.length; i++) {
//      stdout.writeln('[$i] - ${options[i].label}');
//    }

    options.asMap().forEach((index, option) {
      stdout.writeln('[$index] - ${option.label}');
    });

    stdout.writeln('Enter a choice\n');
    stdout.write('>');
  }

  String collectInput() {
    return stdin.readLineSync();
  }

  void clearScreen() {
    if (Platform.isWindows) {
      stdout.write('\x1B[2J\x1B[0f');
    } else {
      stdout.write('\x1B[2J\x1B[3J\x1B[H');
    }
  }
}
